-- About PDF Viewer.lua
-- Uses Chromium
-- 
-- This Addon looks for a PDF saved to your server and displays it in the PDF Viewer within ILLiad
-- Needs Atlas Helpers Addon to run.

-- Load the .NET System Assembly
luanet.load_assembly("System");
Types = {};
Types["Process"] = luanet.import_type("System.Diagnostics.Process");
local settings = {};
-- set scriptActive to true for this script to run, false to stop it from running.
settings.scriptActive = GetSetting("Active");


require "Atlas.AtlasHelpers";
local interfaceMngr = nil;
local PDFViewerForm = {};
PDFViewerForm.Form = nil;
PDFViewerForm.Browser = nil;
PDFViewerForm.RibbonPage = nil;
function Init()
	if settings.scriptActive then

		interfaceMngr = GetInterfaceManager();
		PDFViewerForm.Form = interfaceMngr:CreateForm("PDF Viewer", "Script");
	
		-- Add a browser
		
		if (WebView2Enabled()) then
			PDFViewerForm.Browser = PDFViewerForm.Form:CreateBrowser("PDF Viewer", "PDF Viewer", "Reload", "WebView2");
		else
			PDFViewerForm.Browser = PDFViewerForm.Form:CreateBrowser("PDF Viewer", "PDF Viewer", "Reload", "Chromium");
		end
		-- Hide the text label
		PDFViewerForm.Browser.TextVisible = false;
	
		-- Since we didn't create a ribbon explicitly before creating our browser, it will have created one using the name we passed the CreateBrowser method.  We can retrieve that one and add our buttons to it.
		PDFViewerForm.RibbonPage = PDFViewerForm.Form:GetRibbonPage("Reload");
		
		PDFViewerForm.RibbonPage:CreateButton("Reload", GetClientImage("Search32"), "Reload", "PDFViewer");
		PDFViewerForm.RibbonPage:CreateButton("Open New Browser", GetClientImage("Web32"), "OpenInDefaultBrowser", "Utility")

		PDFViewerForm.Form:Show();
		
	
		Search();
		
	end
end

function Search()
	PDFViewerForm.Browser:RegisterPageHandler("formExists", "searchcoll", "PDFViewerLoaded", false);
	PDFViewerForm.Browser:Navigate(GetSetting("PDF location") .. GetFieldValue("Transaction", "TransactionNumber") .. ".pdf");
	
end



function OpenInDefaultBrowser()
	local currentUrl = PDFViewerForm.Browser.Address;
	
	if (currentUrl and currentUrl ~= "")then
		LogDebug("Opening Browser URL in default browser: " .. currentUrl);

		local process = Types["Process"]();
		process.StartInfo.FileName = currentUrl;
		process.StartInfo.UseShellExecute = true;
		process:Start();
	end
end

function WebView2Enabled()
    return AddonInfo.Browsers ~= nil and AddonInfo.Browsers.WebView2 ~= nil and AddonInfo.Browsers.WebView2 == true;
end